SystemOrganization addCategory: #'Uko-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uko-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'YuriyTymchuk 4/5/2012 15:10'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 32@32.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'YuriyTymchuk 4/4/2012 11:05'!
mouseAction: aBlock 
	^mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'YuriyTymchuk 4/5/2012 12:58'!
mouseUp: anEvent
	self toggleState.
	mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uko-LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'YuriyTymchuk 4/5/2012 15:16'!
cellsPerSide 
	^5! !

!LOGame methodsFor: 'initialization' stamp: 'YuriyTymchuk 4/5/2012 15:16'!
initialize
	| sampleCell width height n |
	super initialize.
	self borderWidth: 5.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (50@50 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'event handling' stamp: 'YuriyTymchuk 4/4/2012 11:26'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'YuriyTymchuk 4/4/2012 11:17'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^c! !

!LOGame methodsFor: 'game logic' stamp: 'YuriyTymchuk 4/4/2012 11:01'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !
